Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.SQLite/3.2/HeuristicLabSQLitePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.SQLite/3.2/HeuristicLabSQLitePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.SQLite/3.2/HeuristicLabSQLitePlugin.cs	(revision 2587)
@@ -26,9 +26,9 @@
 
 namespace HeuristicLab.SQLite {
-  [ClassInfo(Name = "HeuristicLab.SQLite-3.2")]
-  [PluginFile(Filename = "HeuristicLab.SQLite-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [PluginFile(Filename = "System.Data.SQLite.dll", Filetype = PluginFileType.Assembly)]
-  [PluginFile(Filename = "SQLite License.txt", Filetype = PluginFileType.License)]
-  [PluginFile(Filename = "SQLite.NET.chm")]
+  [Plugin("HeuristicLab.SQLite-3.2")]
+  [PluginFile("HeuristicLab.SQLite-3.2.dll", PluginFileType.Assembly)]
+  [PluginFile("System.Data.SQLite.dll", PluginFileType.Assembly)]
+  [PluginFile("SQLite License.txt", PluginFileType.License)]
+  [PluginFile("SQLite.NET.chm", PluginFileType.Data)]
   public class HeuristicLabSQLitePlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Scheduling.JSSP/3.2/HeuristicLabJSSPPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Scheduling.JSSP/3.2/HeuristicLabJSSPPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Scheduling.JSSP/3.2/HeuristicLabJSSPPlugin.cs	(revision 2587)
@@ -26,10 +26,10 @@
 
 namespace HeuristicLab.Scheduling.JSSP {
-  [ClassInfo(Name = "HeuristicLab.Scheduling.JSSP-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Scheduling.JSSP-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Permutation-3.2")]
+  [Plugin("HeuristicLab.Scheduling.JSSP-3.2")]
+  [PluginFile("HeuristicLab.Scheduling.JSSP-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
+  [PluginDependency("HeuristicLab.Permutation-3.2")]
   public class HeuristicLabSchedulingJSPPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.ADODataAccess/3.2/ADODataAccessPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.ADODataAccess/3.2/ADODataAccessPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.ADODataAccess/3.2/ADODataAccessPlugin.cs	(revision 2587)
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Security.DataAccess {
-  [ClassInfo(Name = "HeuristicLab.Security.ADODataAccess-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Security.ADODataAccess-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Plugin("HeuristicLab.Security.ADODataAccess-3.2")]
+  [PluginFile("HeuristicLab.Security.ADODataAccess-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
   public class SecurityDataAccessPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Contracts/3.2/SecurityContractsPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Contracts/3.2/SecurityContractsPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Contracts/3.2/SecurityContractsPlugin.cs	(revision 2587)
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Security.Contracts {
-  [ClassInfo(Name = "HeuristicLab.Security.Contracts-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Security.Contracts-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Plugin("HeuristicLab.Security.Contracts-3.2")]
+  [PluginFile("HeuristicLab.Security.Contracts-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
   public class SecurityContractsPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/PermissionManager.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/PermissionManager.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/PermissionManager.cs	(revision 2587)
@@ -14,5 +14,13 @@
   public class PermissionManager : IPermissionManager{
 
-    private static ISessionFactory factory = ServiceLocator.GetSessionFactory();
+    private static ISessionFactory factory;
+    private static ISessionFactory Factory {
+      get {
+        // lazy initialization
+        if(factory==null) 
+          factory = ServiceLocator.GetSessionFactory();
+        return factory;
+      }      
+    }
 
     private static ISession session;
@@ -51,5 +59,5 @@
     public Guid Authenticate(String userName, String password) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
 
         password = getMd5Hash(password);
@@ -96,5 +104,5 @@
       if (existsSession) {
         try {
-          session = factory.GetSessionForCurrentThread();
+          session = Factory.GetSessionForCurrentThread();
           
           IPermissionOwnerAdapter permOwnerAdapter = session.GetDataAdapter<PermissionOwner, IPermissionOwnerAdapter>();
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/SecurityCorePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/SecurityCorePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/SecurityCorePlugin.cs	(revision 2587)
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Security.Core {
-  [ClassInfo(Name = "HeuristicLab.Security.Core-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Security.Core-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Plugin("HeuristicLab.Security.Core-3.2")]
+  [PluginFile("HeuristicLab.Security.Core-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
   public class SecurityCorePlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/SecurityCoreTest.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/SecurityCoreTest.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/SecurityCoreTest.cs	(revision 2587)
@@ -9,7 +9,5 @@
 
 namespace HeuristicLab.Security.Core {
-    [ClassInfo(Name = "Security Test App",
-        Description = "Test Application for the Security Service",
-        AutoRestart = false)]
+    [Application("Security Test App", "Test Application for the Security Service", false)]
   class SecurityCoreTest : ApplicationBase {
 
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/SecurityManager.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/SecurityManager.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/SecurityManager.cs	(revision 2587)
@@ -13,5 +13,13 @@
   public class SecurityManager : ISecurityManager {
 
-    private static ISessionFactory factory = ServiceLocator.GetSessionFactory();
+    private static ISessionFactory factory;
+    private static ISessionFactory Factory {
+      get {
+        // lazy initialization
+        if(factory==null)
+          factory = ServiceLocator.GetSessionFactory();
+        return factory;
+      }
+    }
 
     private ISession session;
@@ -24,5 +32,5 @@
     public User AddNewUser(User user) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
 
         IUserAdapter userAdapter = session.GetDataAdapter<User, IUserAdapter>();
@@ -46,5 +54,5 @@
     public User UpdateUser(User user) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         IUserAdapter userAdapter = session.GetDataAdapter<User, IUserAdapter>();
 
@@ -67,5 +75,5 @@
     public bool RemoveUser(Guid userId) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         IUserAdapter userAdapter = session.GetDataAdapter<User, IUserAdapter>();
         User user = userAdapter.GetById(userId);
@@ -88,5 +96,5 @@
     public ICollection<User> GetAllUsers() {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         IUserAdapter userAdapter = session.GetDataAdapter<User, IUserAdapter>();
 
@@ -107,5 +115,5 @@
     public User GetUserByName(string name) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         IUserAdapter userAdapter = session.GetDataAdapter<User, IUserAdapter>();
 
@@ -126,5 +134,5 @@
     public User GetUserByLogin(string login) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         IUserAdapter userAdapter = session.GetDataAdapter<User, IUserAdapter>();
 
@@ -145,5 +153,5 @@
     public UserGroup AddNewUserGroup(UserGroup userGroup) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
 
         IUserGroupAdapter userGroupAdapter = session.GetDataAdapter<UserGroup, IUserGroupAdapter>();
@@ -167,5 +175,5 @@
     public UserGroup UpdateUserGroup(UserGroup userGroup) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
 
         IUserGroupAdapter userGroupAdapter = session.GetDataAdapter<UserGroup, IUserGroupAdapter>();
@@ -189,5 +197,5 @@
     public bool RemoveUserGroup(Guid userGroupId) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
 
         IUserGroupAdapter userGroupAdapter = session.GetDataAdapter<UserGroup, IUserGroupAdapter>();
@@ -211,5 +219,5 @@
     public ICollection<UserGroup> GetAllUserGroups() {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         IUserGroupAdapter userGroupAdapter = session.GetDataAdapter<UserGroup, IUserGroupAdapter>();
 
@@ -230,5 +238,5 @@
     public UserGroup GetUserGroupByName(string name) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         IUserGroupAdapter userGroupAdapter = session.GetDataAdapter<UserGroup, IUserGroupAdapter>();
 
@@ -249,5 +257,5 @@
     public PermissionOwner UpdatePermissionOwner(PermissionOwner permissionOwner) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
 
         IPermissionOwnerAdapter permOwnerAdapter = session.GetDataAdapter<PermissionOwner, IPermissionOwnerAdapter>();
@@ -272,5 +280,5 @@
     public bool AddPermissionOwnerToGroup(Guid userGroupId, Guid permissionOwnerId) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         ITransaction transaction = session.BeginTransaction();
 
@@ -305,5 +313,5 @@
     public bool RemovePermissionOwnerFromGroup(Guid userGroupId, Guid permissionOwnerId) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         ITransaction transaction = session.BeginTransaction();
 
@@ -338,5 +346,5 @@
     public bool GrantPermission(Guid permissionOwnerId, Guid permissionId, Guid entityId) {
       try {
-        session = factory.GetSessionForCurrentThread();                         
+        session = Factory.GetSessionForCurrentThread();                         
         IPermissionAdapter permissionAdapter = session.GetDataAdapter<Permission, IPermissionAdapter>();
 
@@ -357,5 +365,5 @@
     public Permission GetPermissionById(Guid permissionId) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
 
         IPermissionAdapter permissionAdapter = session.GetDataAdapter<Permission, IPermissionAdapter>();
@@ -378,5 +386,5 @@
     public bool RevokePermission(Guid permissionOwnerId, Guid permissionId, Guid entityId) {
       try {
-        session = factory.GetSessionForCurrentThread();     
+        session = Factory.GetSessionForCurrentThread();     
         IPermissionAdapter permissionAdapter = session.GetDataAdapter<Permission, IPermissionAdapter>();
  
@@ -392,5 +400,5 @@
     public Permission AddPermission(Permission permission) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         IPermissionAdapter permissionAdapter = session.GetDataAdapter<Permission, IPermissionAdapter>();
 
@@ -411,5 +419,5 @@
     public bool RemovePermission(Guid permissionId) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         IPermissionAdapter permissionAdapter = session.GetDataAdapter<Permission, IPermissionAdapter>();
 
@@ -429,5 +437,5 @@
     public Permission UpdatePermission(Permission permission) {
       try {
-        session = factory.GetSessionForCurrentThread();
+        session = Factory.GetSessionForCurrentThread();
         IPermissionAdapter permissionAdapter = session.GetDataAdapter<Permission, IPermissionAdapter>();
 
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/ServiceLocator.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/ServiceLocator.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Core/3.2/ServiceLocator.cs	(revision 2587)
@@ -10,7 +10,4 @@
 namespace HeuristicLab.Security.Core {
   class ServiceLocator {
-    private static DiscoveryService discoveryService =
-      new DiscoveryService();
-
     private static ISessionFactory sessionFactory = null;
 
@@ -23,5 +20,5 @@
       if (sessionFactory == null) {
         sessionFactory =
-          discoveryService.GetInstances<ISessionFactory>()[0];
+          ApplicationManager.Manager.GetInstances<ISessionFactory>().First();
 
         sessionFactory.DbConnectionType =
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.DataAccess/3.2/SecurityDataAccessPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.DataAccess/3.2/SecurityDataAccessPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.DataAccess/3.2/SecurityDataAccessPlugin.cs	(revision 2587)
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Security.DataAccess {
-  [ClassInfo(Name = "HeuristicLab.Security.DataAccess-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Security.DataAccess-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Plugin("HeuristicLab.Security.DataAccess-3.2")]
+  [PluginFile("HeuristicLab.Security.DataAccess-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
   public class SecurityDataAccessPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Server/3.2/SecurityServerApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Server/3.2/SecurityServerApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Server/3.2/SecurityServerApplication.cs	(revision 2587)
@@ -6,4 +6,5 @@
 using System.ServiceModel.Description;
 using System.Net;
+using System.Linq;
 using HeuristicLab.Security.Contracts.Interfaces;
 using System.Windows.Forms;
@@ -11,15 +12,12 @@
 namespace HeuristicLab.Security.Server {
 
-  [ClassInfo(Name = "Security Server",
-  Description = "Server application for the security.",
-  AutoRestart = true)]
+  [Application("Security Server", "Server application for the security.", true)]
   public class SecurityServerApplication : ApplicationBase {
     public const string STR_PermissionManager = "PermissionManager";
-    public const string STR_SecurityManager = "SecurityManager";   
+    public const string STR_SecurityManager = "SecurityManager";
 
     int DEFAULT_PORT_SM = 9111;
     int DEFAULT_PORT_PM = 9112;
 
-    private DiscoveryService discService = new DiscoveryService();
     private Dictionary<string, ServiceHost> runningServices = new Dictionary<string, ServiceHost>();
     private NetTcpBinding binding = (NetTcpBinding)HeuristicLab.Hive.Contracts.WcfSettings.GetBinding();
@@ -30,5 +28,5 @@
       All
     }
-    
+
     private bool AddMexEndpoint(ServiceHost serviceHost) {
       if (serviceHost != null) {
@@ -48,12 +46,12 @@
       Uri uriTcp;
       String result = "";
-      ISecurityManager[] securityManagerInstances = discService.GetInstances<ISecurityManager>();
-      IPermissionManager[] permissionManagerInstances = discService.GetInstances<IPermissionManager>();
+      IEnumerable<ISecurityManager> securityManagerInstances = ApplicationManager.Manager.GetInstances<ISecurityManager>();
+      IEnumerable<IPermissionManager> permissionManagerInstances = ApplicationManager.Manager.GetInstances<IPermissionManager>();
       ServiceHost serviceHost = null;
       switch (svc) {
         case Services.PermissionManager:
-          if (permissionManagerInstances.Length > 0) {
-            uriTcp = new Uri("net.tcp://" + ipAddress + ":" + port + "/SecurityServer/"); 
-            serviceHost = new ServiceHost(permissionManagerInstances[0].GetType(), uriTcp);
+          if (permissionManagerInstances.Count() > 0) {
+            uriTcp = new Uri("net.tcp://" + ipAddress + ":" + port + "/SecurityServer/");
+            serviceHost = new ServiceHost(permissionManagerInstances.First().GetType(), uriTcp);
             serviceHost.AddServiceEndpoint(typeof(IPermissionManager), binding, STR_PermissionManager);
             curServiceHost = STR_PermissionManager;
@@ -62,7 +60,7 @@
           break;
         case Services.SecurityManager:
-          if (securityManagerInstances.Length > 0) {
+          if (securityManagerInstances.Count() > 0) {
             uriTcp = new Uri("net.tcp://" + ipAddress + ":" + port + "/SecurityServer/");
-            serviceHost = new ServiceHost(securityManagerInstances[0].GetType(), uriTcp);
+            serviceHost = new ServiceHost(securityManagerInstances.First().GetType(), uriTcp);
             serviceHost.AddServiceEndpoint(typeof(ISecurityManager), binding, STR_SecurityManager);
             curServiceHost = STR_SecurityManager;
@@ -77,5 +75,5 @@
       if ((serviceHost != null) && (!String.IsNullOrEmpty(curServiceHost))) {
         AddMexEndpoint(serviceHost);
-    //    WcfSettings.SetServiceCertificate(serviceHost);
+        //    WcfSettings.SetServiceCertificate(serviceHost);
         serviceHost.Open();
         runningServices.Add(curServiceHost, serviceHost);
@@ -112,5 +110,5 @@
             break;
       }
-      
+
       //Start services and record their base address
       Dictionary<string, String> baseAddrDict = new Dictionary<string, String>();
@@ -126,4 +124,4 @@
       StopService(Services.All);
     }
-  }                                                                                      
+  }
 }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Server/3.2/SecurityServerPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Server/3.2/SecurityServerPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Security.Server/3.2/SecurityServerPlugin.cs	(revision 2587)
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Security.Server {
-  [ClassInfo(Name = "HeuristicLab.Security.Server-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Security.Server-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Plugin("HeuristicLab.Security.Server-3.2")]
+  [PluginFile("HeuristicLab.Security.Server-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
   public class SecurityServerPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Selection.OffspringSelection/3.2/HeuristicLabSelectionOffspringSelectionPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Selection.OffspringSelection/3.2/HeuristicLabSelectionOffspringSelectionPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Selection.OffspringSelection/3.2/HeuristicLabSelectionOffspringSelectionPlugin.cs	(revision 2587)
@@ -29,8 +29,8 @@
   /// Plugin class for HeuristicLab.Selection.OffspringSelection plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.Selection.OffspringSelection-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Selection.OffspringSelection-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
+  [Plugin("HeuristicLab.Selection.OffspringSelection-3.2")]
+  [PluginFile("HeuristicLab.Selection.OffspringSelection-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
   public class HeuristicLabSelectionOffspringSelectionPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Selection.Uncertainty/3.2/UncertaintyPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Selection.Uncertainty/3.2/UncertaintyPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Selection.Uncertainty/3.2/UncertaintyPlugin.cs	(revision 2587)
@@ -27,12 +27,12 @@
 
 namespace HeuristicLab.Selection.Uncertainty {
-  [ClassInfo(Name = "HeuristicLab.Selection.Uncertainty-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Selection.Uncertainty-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Selection-3.2")]
-  [Dependency(Dependency = "HeuristicLab.StatisticalAnalysis-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Random-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Tracing-3.2")]
+  [Plugin("HeuristicLab.Selection.Uncertainty-3.2")]
+  [PluginFile("HeuristicLab.Selection.Uncertainty-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Selection-3.2")]
+  [PluginDependency("HeuristicLab.StatisticalAnalysis-3.2")]
+  [PluginDependency("HeuristicLab.Random-3.2")]
+  [PluginDependency("HeuristicLab.Tracing-3.2")]
   public class UncertaintyPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Selection/3.2/HeuristicLabSelectionPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Selection/3.2/HeuristicLabSelectionPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Selection/3.2/HeuristicLabSelectionPlugin.cs	(revision 2587)
@@ -29,9 +29,9 @@
   /// Plugin class for HeuristicLab.Selection plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.Selection-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Selection-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
+  [Plugin("HeuristicLab.Selection-3.2")]
+  [PluginFile("HeuristicLab.Selection-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
   public class HeuristicLabSelectionPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.SequentialEngine/3.2/HeuristicLabSequentialEnginePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.SequentialEngine/3.2/HeuristicLabSequentialEnginePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.SequentialEngine/3.2/HeuristicLabSequentialEnginePlugin.cs	(revision 2587)
@@ -29,7 +29,7 @@
   /// Plugin class for HeuristicLab.SequentialEngine plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.SequentialEngine-3.2")]
-  [PluginFile(Filename = "HeuristicLab.SequentialEngine-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Plugin("HeuristicLab.SequentialEngine-3.2")]
+  [PluginFile("HeuristicLab.SequentialEngine-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
   public class HeuristicLabSequentialEnginePlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.SimOpt/3.2/HeuristicLabSimOptPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.SimOpt/3.2/HeuristicLabSimOptPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.SimOpt/3.2/HeuristicLabSimOptPlugin.cs	(revision 2587)
@@ -27,13 +27,13 @@
 
 namespace HeuristicLab.SimOpt {
-  [ClassInfo(Name = "HeuristicLab.SimOpt-3.2")]
-  [PluginFile(Filename = "HeuristicLab.SimOpt-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Constraints-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Evolutionary-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Selection-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Random-3.2")]
+  [Plugin("HeuristicLab.SimOpt-3.2")]
+  [PluginFile("HeuristicLab.SimOpt-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
+  [PluginDependency("HeuristicLab.Constraints-3.2")]
+  [PluginDependency("HeuristicLab.Evolutionary-3.2")]
+  [PluginDependency("HeuristicLab.Selection-3.2")]
+  [PluginDependency("HeuristicLab.Random-3.2")]
   public class HeuristicLabSimOptPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.SimOpt/3.2/SimOptProblemInjectorView.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.SimOpt/3.2/SimOptProblemInjectorView.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.SimOpt/3.2/SimOptProblemInjectorView.cs	(revision 2587)
@@ -71,11 +71,9 @@
     private void UpdateDataTypeTreeView() {
       dataTypeTreeView.Nodes.Clear();
-      DiscoveryService discoveryService = new DiscoveryService();
-      foreach (PluginInfo plugin in discoveryService.Plugins) {
+      foreach (IPluginDescription plugin in ApplicationManager.Manager.Plugins) {
         TreeNode pluginNode = new TreeNode(plugin.Name);
         pluginNode.Tag = null;
 
-        Type[] types = discoveryService.GetTypes(typeof(IObjectData), plugin);
-        foreach (Type type in types) {
+        foreach (Type type in ApplicationManager.Manager.GetTypes(typeof(IObjectData), plugin)) {
           if (!type.IsAbstract) {
             TreeNode itemNode = new TreeNode();
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.StatisticalAnalysis/3.2/HeuristicLabStatisticalAnalysisPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.StatisticalAnalysis/3.2/HeuristicLabStatisticalAnalysisPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.StatisticalAnalysis/3.2/HeuristicLabStatisticalAnalysisPlugin.cs	(revision 2587)
@@ -27,9 +27,9 @@
 
 namespace HeuristicLab.StatisticalAnalysis {
-  [ClassInfo(Name = "HeuristicLab.StatisticalAnalysis-3.2")]
-  [PluginFile(Filename = "HeuristicLab.StatisticalAnalysis-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Random-3.2")]
+  [Plugin("HeuristicLab.StatisticalAnalysis-3.2")]
+  [PluginFile("HeuristicLab.StatisticalAnalysis-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Random-3.2")]
   public class HeuristicLabStatisticalAnalysisPlugin : PluginBase {
   }
